unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;
  VSX, VSY: integer;
  BitmapOrg, BitmapNew: TBitmap;

implementation

{$R *.DFM}

//
//  rbg}bvt@C̓ǂݍ
//
procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    BitmapOrg.LoadfromFile(OpenDialog1.FileName);
    Image1.Picture.Bitmap := BitmapOrg;
    SaveDialog1.Filename := OpenDialog1.FileName;
    ScrollBox1.VertScrollBar.Position := 0;
    ScrollBox1.HorzScrollBar.Position := 0;
    If Image1.Width < VSX then
      Image1.Left := (VSX - Image1.Width) div 2
    else
      Image1.Left := 0;
    If Image1.Height < VSY then
      Image1.Top := (VSY - Image1.Height) div 2
    else
      Image1.Top := 0;
    RadioButton1.Enabled := true;
    RadioButton1.Checked := true;
    RadioButton2.Enabled := false;
    Button2.Enabled := true;
    Button3.Enabled := true;
  end;
end;

//
//  rbg}bvt@C̏
//
procedure TForm1.Button3Click(Sender: TObject);
begin
  if SaveDialog1.Execute then begin
    Image1.Picture.SaveToFile(OpenDialog1.FileName);
    OpenDialog1.Filename := SaveDialog1.FileName;
  end;
end;

//
//  Button2Click̉
//
procedure putpixel(xw, yw, x, y : integer; c : longint);
begin
  if x < 0 then exit;
  if y < 0 then exit;
  if x > xw then exit;
  if y > yw then exit;
  if c <> ColorToRGB(BitmapNew.Canvas.Pixels[x, y]) then exit;
  BitmapNew.Canvas.Pixels[x, y] := 0;
end;

//
//  g郋[`
//
procedure TForm1.Button2Click(Sender: TObject);
var
  xw, yw, x, y : integer;
  c, w : longint;
begin
  BitmapNew.Assign(BitmapOrg);
  c := ColorToRGB(BitmapNew.Canvas.Pixels[0, 0]);
  xw := BitmapNew.Width - 1;
  yw := BitmapNew.Height - 1;
  for x := 0 to xw do begin
    for y := 0 to yw do begin
      w := ColorToRGB(BitmapNew.Canvas.Pixels[x, y]);
      if (w <> c) and (w <> 0) then begin
        putpixel(xw, yw, x - 1, y, c);
        putpixel(xw, yw, x + 1, y, c);
        putpixel(xw, yw, x, y - 1, c);
        putpixel(xw, yw, x, y + 1, c);
      end;
    end;
  end;
  Image1.Picture.Bitmap := BitmapNew;
  RadioButton2.Enabled := true;
  RadioButton2.Checked := true;
  Button2.Enabled := false;
end;

//
//  ݒ
//
procedure TForm1.FormCreate(Sender: TObject);
begin
  VSX := Image1.Width;
  VSY := Image1.Height;
  BitmapOrg := TBitmap.Create;
  BitmapNew := TBitmap.Create;
end;

//
//  ȊǑn
//
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  BitmapOrg.Free;
  BitmapNew.Free;
end;

//
//  ϊỎ摜\
//
procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  Image1.Picture.Bitmap := BitmapOrg;
end;

//
//  ϊ̉摜\
//
procedure TForm1.RadioButton2Click(Sender: TObject);
begin
  Image1.Picture.Bitmap := BitmapNew;
end;

end.
